// 2007-02-18
#pragma once
#include "ControlReaders/ControlReader.h"
#include "ControlReaders/TextReader.h"
#include "ControlReaders/ListReader.h"

class ComboBoxReader : public ControlReader
{
	//---- Fields ----
	private:
		TextReader *	_TextReader;
		ListReader *	_ListReader;

	//---- Init / Dispose ----
	public:
		ComboBoxReader( ISpeakable * speaker );
		virtual ~ComboBoxReader();

	//---- ControlReader interface ----
	protected:
		virtual bool CanHandleContext( long vmID, AccessibleContext context, AccessibleContextInfo & contextInfo );
		virtual void OnFocusGained( long vmID, FocusEvent event, AccessibleContext context, AccessibleContextInfo & contextInfo );
		virtual void OnCaretPropertyChange( long vmID, CaretEvent event, AccessibleContext context, AccessibleContextInfo & contextInfo, int oldPosition, int newPosition );
		virtual void OnSelectionPropertyChange( long vmID, jobject event, AccessibleContext context, AccessibleContextInfo & contextInfo );
};
