// file    : ControlReader.cpp
// brief   : defines base implementation for control readers
// author  : SGRY (YAMAMOTO Suguru)
// update  : 2007-03-01 (SGRY)
// license : MIT License (see END of this file)
//=========================================================
#include "ControlReader.h"

ControlReader::ControlReader( ISpeakable * speaker )
{
	this->_SpeakerRef = speaker;
}

void
ControlReader::OnFocusGained( long, FocusEvent, AccessibleContext, AccessibleContextInfo & )
{}

void
ControlReader::OnJavaShutdown( long )
{}

void
ControlReader::OnCaretUpdate( long, CaretEvent, AccessibleContext, AccessibleContextInfo & )
{}

void
ControlReader::OnMenuDeselected( long, jobject, AccessibleContext, AccessibleContextInfo & )
{}

void
ControlReader::OnMenuSelected( long, CaretEvent, AccessibleContext, AccessibleContextInfo & )
{}

void
ControlReader::OnCaretPropertyChange( long, CaretEvent, AccessibleContext, AccessibleContextInfo &, int, int )
{}

void
ControlReader::OnStatePropertyChange( long, jobject, AccessibleContext, AccessibleContextInfo &, wchar_t *, wchar_t * )
{}

void
ControlReader::OnSelectionPropertyChange( long, jobject, AccessibleContext, AccessibleContextInfo & )
{}

void
ControlReader::OnActiveDescendentPropertyChange( long, jobject, AccessibleContext, AccessibleContextInfo &, jobject, jobject )
{}


/**********************************************************
Copyright (c) 2006-2007 YAMAMOTO Suguru

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
copies of the Software, and to permit persons to whom the Software is 
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN 
THE SOFTWARE.
**********************************************************/
