// 2007-02-28
#pragma once

#include <AccessBridgeCalls.h>
#include "Utilities.h"
#include "Speakers/ISpeakable.h"

//-------------------------------------
// class : ControlReader <<interface>>
//-------------------------------------
class ControlReader
{
	protected:
		ISpeakable * _SpeakerRef;

	public:
		ControlReader( ISpeakable * speaker );
		
		virtual bool CanHandleContext( long vmID, AccessibleContext context, AccessibleContextInfo & contextInfo ) = 0;
		virtual void OnFocusGained( long vmID, FocusEvent event, AccessibleContext context, AccessibleContextInfo & contextInfo );
		virtual void OnJavaShutdown( long vmID );
		virtual void OnCaretUpdate( long vmID, CaretEvent event, AccessibleContext context, AccessibleContextInfo & contextInfo );
		virtual void OnMenuDeselected( long vmID, jobject event, AccessibleContext context, AccessibleContextInfo & contextInfo );
		virtual void OnMenuSelected( long vmID, jobject event, AccessibleContext context, AccessibleContextInfo & contextInfo );
		virtual void OnCaretPropertyChange( long vmID, CaretEvent event, AccessibleContext context, AccessibleContextInfo & contextInfo, int oldPosition, int newPosition );
		virtual void OnStatePropertyChange( long vmID, jobject event, AccessibleContext context, AccessibleContextInfo & contextInfo, wchar_t * oldState, wchar_t * newState );
		virtual void OnSelectionPropertyChange( long vmID, jobject event, AccessibleContext context, AccessibleContextInfo & contextInfo );
		virtual void OnActiveDescendentPropertyChange( long vmID, jobject event, AccessibleContext context, AccessibleContextInfo & contextInfo, jobject oldActiveDescendent, jobject newActiveDescendent );
};
