// 2007-10-08
#pragma once
#include <string>
#include "Speakers/ISpeakable.h"

class FocusTalk : public ISpeakable
{
	//---- types ----
	private:
		typedef BOOL (WINAPI * FT_OutputVoiceTextProc)( const char* text, int flags );
		typedef BOOL (WINAPI * FT_StopSoundProc)();
		typedef BOOL (WINAPI * FT_IsSoundBusyProc)();
		typedef int (WINAPI * FT_ChangeVoiceTypeProc)( int type );
		typedef int (WINAPI * FT_GetVoiceTypeProc)();

	//---- fields ----
	private:
		HMODULE					_Dll;
		FT_OutputVoiceTextProc	FT_OutputVoiceText;
		FT_StopSoundProc		FT_StopSound;
		FT_IsSoundBusyProc		FT_IsSoundBusy;
		FT_ChangeVoiceTypeProc	FT_ChangeVoiceType;
		FT_GetVoiceTypeProc		FT_GetVoiceType;

	//---- Init / Dispose ----
	public:
		FocusTalk();
		~FocusTalk();
		int Init();

	//---- ISpeakable ----
	public:
		virtual void Speak( const wchar_t* str );
		virtual void SpeakLow( const wchar_t * str );
		virtual void SpeakAndWait( const wchar_t* str );
		virtual void Wait( bool waitLong );
		virtual void ShutUp();

		virtual std::wstring GetTextForTripleDots();
};
