// 2007-06-15
#pragma once
#include "Sgry.h"

class ISpeakable
{
	//---- interface ----
	public:
		virtual void Speak( const wchar_t* str ) = 0;
		virtual void SpeakLow( const wchar_t * str ) = 0;
		virtual void SpeakAndWait( const wchar_t* str ) = 0;
		virtual void Wait( bool waitLong ) = 0;
		virtual void ShutUp() = 0;

		virtual std::wstring GetTextForTripleDots() = 0;

	//---- glue inline functions ----
	public:
		inline void Speak( const std::wstring str )
		{
			Speak( str.c_str() );
		}
		inline void SpeakLow( const std::wstring str )
		{
			SpeakLow( str.c_str() );
		}
		inline void SpeakAndWait( const std::wstring str )
		{
			SpeakAndWait( str.c_str() );
		}
};
