// 2007-05-27
#pragma once
#include <windows.h>
#include <string>
#include "Speakers\ISpeakable.h"

class Jaws : public ISpeakable
{
	//---- types ----
	private:
		typedef BOOL (WINAPI * JFWSayStringProc)( LPCTSTR stringToSpeak, BOOL interrupt );
		typedef BOOL (WINAPI * JFWStopSpeechProc)();

	//---- fields ----
	private:
		HMODULE				_Dll;
		JFWSayStringProc	JFWSayString;
		JFWStopSpeechProc	JFWStopSpeech;

	//---- init / dispose ----
	public:
		Jaws();
		virtual ~Jaws();
		int Init();

	//---- ISpeakable interface ----
	public:
		virtual void Speak( const wchar_t * str );
		virtual void SpeakLow( const wchar_t * str );
		virtual void SpeakAndWait( const wchar_t* str );
		virtual void Wait( bool waitLong );
		virtual void ShutUp();

		virtual std::wstring GetTextForTripleDots();
};
