// 2007-05-27
#pragma once
#include <windows.h>
#include <string>
#include "ISpeakable.h"

class PCTalker : public ISpeakable
{
	//---- types ----
	private:
		typedef void (* PCTKPReadProc)( const char* string, int priority, BOOL analyze );
		typedef BOOL (* PCTKStatusProc)();
		typedef void (* PCTKVResetProc)();
		typedef DWORD (* PCTKGetStatusProc)( UINT item, void* param1, void* param2 );
		typedef DWORD (* PCTKSetStatusProc)( UINT item, void* param1, void* param2 );
		typedef BOOL (WINAPI * SoundStatusProc)();

	//---- fields ----
	private:
		HMODULE				_Dll;
		PCTKPReadProc		PCTKPRead;
		PCTKStatusProc		PCTKStatus;
		PCTKVResetProc		PCTKVReset;
		PCTKGetStatusProc	PCTKGetStatus;
		PCTKSetStatusProc	PCTKSetStatus;
		SoundStatusProc		SoundStatus;

	//---- Init / Dispose ----
	public:
		PCTalker();
		~PCTalker();
		int Init();

	//---- ISpeakable ----
	public:
		virtual void Speak( const wchar_t * str );
		virtual void SpeakLow( const wchar_t * str );
		virtual void SpeakAndWait( const wchar_t* str );
		virtual void Wait( bool waitLong );
		virtual void ShutUp();

		virtual std::wstring GetTextForTripleDots();
};
