// 2007-06-15
#pragma once
#include <string>
#include "Speakers/ISpeakable.h"

class XPReader : public ISpeakable
{
	//---- types ----
	private:
		typedef BOOL (WINAPI * SoundMessageProc)( const char* text, int flags );
		typedef BOOL (WINAPI * SoundStopProc)();
		typedef BOOL (WINAPI * SoundStatusProc)();
		typedef int (WINAPI * SoundModifyModeProc)( int on, int off );

	//---- fields ----
	private:
		HMODULE				_Dll;
		SoundMessageProc	SoundMessage;
		SoundStopProc		SoundStop;
		SoundStatusProc		SoundStatus;
		SoundModifyModeProc	SoundModifyMode;

	//---- Init / Dispose ----
	public:
		XPReader();
		~XPReader();
		int Init();

	//---- ISpeakable ----
	public:
		virtual void Speak( const wchar_t* str );
		virtual void SpeakLow( const wchar_t * str );
		virtual void SpeakAndWait( const wchar_t* str );
		virtual void Wait( bool waitLong );
		virtual void ShutUp();

		virtual std::wstring GetTextForTripleDots();
};
