#pragma once

#include <vector>
#include "Speakers/ISpeakable.h"
#include "ControlReaders/ControlReader.h"


class SwingEventServer
{
	private:
		typedef std::vector<ControlReader *> ControlReaders;
		static ControlReaders _ControlReaders;
		ISpeakable * _Speaker;
		static bool _InstanceCreated;

	// Init / Dispose
	public:
		SwingEventServer();
		~SwingEventServer();
		int Init();
	private:
		ISpeakable * CreateSpeaker();

	// event sinks
	public:
		static void OnFocusGained( long vmID, FocusEvent event, AccessibleContext context );
		static void OnJavaShutdown( long vmID );
		static void OnCaretUpdate( long vmID, CaretEvent event, AccessibleContext context );
		static void OnMenuDeselected( long vmID, jobject event, AccessibleContext source );
		static void OnMenuSelected( long vmID, jobject event, AccessibleContext context );
		static void OnCaretPropertyChange( long vmID, CaretEvent event, AccessibleContext context, int oldPosition, int newPosition );
		static void OnStatePropertyChange( long vmID, jobject event, AccessibleContext context, wchar_t * oldState, wchar_t * newState );
		static void OnSelectionPropertyChange( long vmID, jobject event, jobject context );
		static void OnActiveDescendentPropertyChange( long vmID, jobject event, AccessibleContext context, jobject oldActiveDescendent, jobject newActiveDescendent );
};
