@echo off
setlocal

echo Compiling SwingReader...

set package_dir=..\package
if not exist %package_dir% (
	mkdir %package_dir%
)

set assembly_name=SwingReader.exe

::-------------------------------------
:: Check environment
::-------------------------------------

:: Check whether the UPX.EXE is available or not
(upx > NUL) 2> NUL
if not ERRORLEVEL == 9009  set _UPX_OK_=1

:: Check whether the CL.EXE is available or not
(cl > NUL) 2> NUL
if not ERRORLEVEL == 9009  goto build_vc

:: Check whether the g++.exe is available or not
(g++ > NUL) 2> NUL
if not ERRORLEVEL == 9009  goto build_gcc

echo no supported compiler was installed in this environment.
GOTO end


::-------------------------------------
:: Compiling with Visual C++
::-------------------------------------
:build_vc
call build_vc.bat

goto end
::-------------------------------------
:: Compiling with GNU C++ (MinGW)
::-------------------------------------
:build_gcc
call build_gcc.bat

:end
if  %_UPX_OK_% == 1 (
	upx -q -9 %package_dir%\%assembly_name%
)
echo.
