@echo off

if "%package_dir%" == "" (
	set package_dir=..\package
)
if "%assembly_name%" == "" (
	set assembly_name=SwingReader.exe
)

:: -O2: optimize size
:: -EHsc: enable C++ exception
set options=-O2 -EHsc -Fe%assembly_name% -DNDEBUG -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NON_CONFORMING_SWPRINTFS
set includes=-I..  -I ..\JavaAccessBridge
set includes=%includes%  -I ..\ControlReaders  -I ..\Speakers
set resource=..\SwingReader.rc
set sources=..\*.cpp  ..\*.res  ..\Sgry\*.cpp  ..\JavaAccessBridge\*.c*
set sources=%sources%  ..\Speakers\*.cpp  ..\ControlReaders\*.cpp
set libraries=user32.lib advapi32.lib
set link_options=-link -subsystem:windows -entry:mainCRTStartup

:: go into workspace
if not exist obj (
	mkdir obj 2> NUL
)
cd obj

:: build
if not "%resource%" == "" (
	rc %resource%
)
if not "sources" == "" (
	cl  -nologo  %options%  %includes%  %libraries%  %sources%  %link_options%
)
:: get out from workspace
cd..

:: move assembly to package directory
move /Y  obj\%assembly_name%  %package_dir%\
