; NSIS(Nullsoft Install System) script
; for SwingReader
; encoding: Shift_JIS
; update: 2008-01-24

;--------------------------------
; Installer Setting

BrandingText "SwingReader installer / NSIS 2.34 custom"

; load language files
LoadLanguageFile  "${NSISDIR}\Contrib\Language files\Japanese.nlf"
LoadLanguageFile  "${NSISDIR}\Contrib\Language files\English.nlf"

; Set compression method
SetCompressor /SOLID lzma

; enable WinXP Visual Style
XPStyle  on

; product name displayed in installer
LangString  Name ${LANG_JAPANESE} "SwingReader"
LangString  Name ${LANG_ENGLISH} "SwingReader"
Name  $(Name)

; installer file name
OutFile  "SwingReader100.exe"

; the default installation directory
InstallDir  $PROGRAMFILES\SwingReader

; show details without pressing "detail" button.
; because the button cannot be accessed with keyboard.
ShowInstDetails  show
ShowUninstDetails  show



;--------------------------------
; License agreement data

LicenseLangString  myLicenseData ${LANG_JAPANESE} "license_ja.txt"
LicenseLangString  myLicenseData ${LANG_ENGLISH} "license.txt"

LicenseData  $(myLicenseData)


;--------------------------------
; Pages

Page  license
Page  directory
Page  instfiles  ""  MyNotifyBeginInstallation

UninstPage  uninstConfirm
UninstPage  instfiles


;--------------------------------
; Installation section

Section "Install"

	SetOutPath $INSTDIR\lang
	File ..\package\lang\*
	
	SetOutPath  $INSTDIR
	File  ..\package\SwingReader.exe
	File  ..\package\SwingReader.txt
	File  ..\package\accessbridge-2_0_1.exe
	
	; write uninstall information to registry
	WriteRegStr  HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SGRY SwingReader" "DisplayName" "SwingReader 1.0.0"
	WriteRegStr  HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SGRY SwingReader" "UninstallString" '"$INSTDIR\UnInstallSwingReader.exe"'
	WriteRegStr  HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SGRY SwingReader" "Publisher" "YAMAMOTO Suguru"
	WriteRegStr  HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SGRY SwingReader" "URLInfoAbout" "http://sgry.jp/swingreader/"
	WriteRegDWORD  HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SGRY SwingReader" "NoModify" 1
	WriteRegDWORD  HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SGRY SwingReader" "NoRepair" 1
	WriteUninstaller  "UnInstallSwingReader.exe"
	
	; create shortcut in start menu
	CreateDirectory  "$SMPROGRAMS\SwingReader"
	CreateShortCut  "$SMPROGRAMS\SwingReader\SwingReader.lnk"  "$INSTDIR\SwingReader.exe"
	CreateShortCut  "$SMPROGRAMS\SwingReader\SwingReader }jA.lnk"  "$INSTDIR\SwingReader.txt"
	CreateShortCut  "$SMPROGRAMS\SwingReader\Java Access Bridge 2.0 ăCXg[.lnk"  "$INSTDIR\accessbridge-2_0_1.exe"

SectionEnd


;--------------------------------
; Uninstall section

Section "Uninstall"

	; remove files and uninstaller
	Delete  $INSTDIR\SwingReader.exe
	Delete  $INSTDIR\SwingReader.txt
	RMDir /r  $INSTDIR\lang
	RMDir /r  $INSTDIR\Documents
	RMDir /r  $INSTDIR\icons
	RMDir  $INSTDIR
	
	; remove uninstall information on registry
	DeleteRegKey  HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SGRY SwingReader"
	
	; remove shortcut in start menu
	RMDir /r  "$SMPROGRAMS\SwingReader"

SectionEnd


;--------------------------------
; Callback hook functions

; function called dualing the initialization process
Function .onInit

	Push  ""
	Push  ${LANG_JAPANESE}
	Push  Japanese
	Push  ${LANG_ENGLISH}
	Push  English
	Push  A ; A means auto count languages
	        ; for the auto count to work the first empty push (Push "") must remain
	
	; language selection dialog
	LangDLL::LangDialog  "Installer Language" "Please select the language of the installer"
	Pop  $LANGUAGE
	StrCmp  $LANGUAGE "cancel" 0 end
		Abort
	
	end:

FunctionEnd

; functions called when the installation successfully finished
Function .onInstSuccess
	StrCmp  $LANGUAGE "1041" 0 +3
		MessageBox MB_OK  " Java Access Bridge ̃CXg[N܂B"
		Goto +2
		MessageBox MB_OK  "Press OK to launch installer of Java Access Bridge."
	
	Exec $INSTDIR\accessbridge-2_0_1.exe
	
	Abort
FunctionEnd

; 
Function MyNotifyBeginInstallation
	StrCmp  $LANGUAGE "1041" 0 +3
		MessageBox MB_OK  "CXg[Jn܂"
		Goto +2
		MessageBox MB_OK  "Begining installation"
	Abort
FunctionEnd
